#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[] = "0.8";

#define ACCESS_CONSOLE	131072
#define ACCESS_RESTRICT 8192

#define MENU_NONE		0
#define MENU_RIFLES     4
#define MENU_PRIMAMMO	6
#define MENU_SECAMMO	7
#define MENU_EQUIPMENT	8
#define MENU_INVALID    9
#define MENU_CANCEL		10
#define MENU_MAIN		11
#define AWP_T	5
#define AWP_CT	6

new g_sb_awplimit = 0;
new g_AwpTeamCount[3];
new g_AwpCount[MAX_PLAYERS];
new g_UserMenuSelected[MAX_PLAYERS];
new g_commencing;

public plugin_init() {
	plugin_registerinfo("AWP team-limit script","Lets you limit how many awps are allowed in team.",STRING_VERSION);
	plugin_registercmd("admin_awplimit","admin_awplimit",ACCESS_RESTRICT,"admin_awplimit <limit>: Changes the limit for amount of AWP purchases each team, 0 for no limit.");
	plugin_registercmd("admin_checkawp","CheckAWP",ACCESS_RESTRICT);
	//User command events:
	plugin_registercmd("buy","buy",ACCESS_ALL);
	plugin_registercmd("buyequip","buyequip",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	plugin_registercmd("radio1","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio2","ClearMenu",ACCESS_ALL);
	plugin_registercmd("radio3","ClearMenu",ACCESS_ALL);
	plugin_registercmd("chooseteam","ClearMenu",ACCESS_ALL);
	//plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registercmd("awp","awp",ACCESS_ALL);
	plugin_registercmd("weapon_awp","weapon_awp",ACCESS_ALL);
	

	plugin_registercmd("awp_kill", "awp_kill", ACCESS_CONSOLE);
	exec( "logd_reg 57 admin_command awp_kill" );		/*KILL-EVENT*/
	plugin_registercmd("awp_injure", "awp_injure", ACCESS_CONSOLE);
	exec( "logd_reg 58 admin_command awp_injure" );		/*INJURE-EVENT*/
	plugin_registercmd("awp_world", "awp_world", ACCESS_CONSOLE);
	exec( "logd_reg 62 admin_command awp_world" );		/*WORLD-EVENT*/
	
	
	//Get vault value to save across map changes and stuff
	get_vaultnumdata("admin_awpteamlimit",g_sb_awplimit);
	return PLUGIN_CONTINUE;
}

public CheckAWP(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	new iTeam;
	
	selfmessage("******* AWP CHECK *******");
	snprintf(Text,MAX_TEXT_LENGTH,"* AWPs restricted for each team: %i",g_sb_awplimit);
	selfmessage(Text);
	selfmessage("*** Terror Team: ***");
	snprintf(Text,MAX_TEXT_LENGTH,"* total AWPs: %i",g_AwpTeamCount[1]);
	selfmessage(Text);
	selfmessage("*** Counter Team: ***");
	snprintf(Text,MAX_TEXT_LENGTH,"* total AWPs: %i",g_AwpTeamCount[2]);
	selfmessage(Text);
	selfmessage("*** Players: ***");
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH,_,_,iTeam)){
			if(g_AwpCount[i]==1){
				if(iTeam==1){
					snprintf(Text,MAX_TEXT_LENGTH,"* - %s (Terror)",Player);
				}else if(iTeam==2){
					snprintf(Text,MAX_TEXT_LENGTH,"* - %s (Counter)",Player);
				}else{
					snprintf(Text,MAX_TEXT_LENGTH,"* - %s",Player);
				}
				selfmessage(Text);
			}
		}
	}
	return PLUGIN_HANDLED;
}

public admin_awplimit(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	//Data[0] means Data isn't empty (usually)
	if (strlen(Data)!=0) {
		g_sb_awplimit = strtonum(Data);
		set_vaultnumdata("admin_awpteamlimit",g_sb_awplimit);
	}
	//Tell the admin what the limit is (does it even if it was empty so it just reports)
	snprintf(Text, MAX_TEXT_LENGTH, "AWP team limit is set to ^"%i^" awps", g_sb_awplimit);
	messageex(User, Text, print_console);
	return PLUGIN_HANDLED;
}

public buy(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_MAIN;
    return PLUGIN_CONTINUE;
}

public buyequip(HLCommand,HLData,HLUserName,UserIndex){
    g_UserMenuSelected[UserIndex] = MENU_EQUIPMENT;
    return PLUGIN_CONTINUE;
}

public ClearMenu(HLCommand,HLData,HLUserName,UserIndex) {
    g_UserMenuSelected[UserIndex] = MENU_NONE;
    return PLUGIN_CONTINUE;
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(g_UserMenuSelected[UserIndex] != MENU_NONE && g_sb_awplimit !=0){
		new Data[MAX_DATA_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iSelectedNumber;
		new iTeam;
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		iSelectedNumber=strtonum(Data);
		
		if(iSelectedNumber == MENU_CANCEL) {
			g_UserMenuSelected[UserIndex] = MENU_NONE;
		}	
		if(g_UserMenuSelected[UserIndex]==MENU_MAIN){
			if(iSelectedNumber == MENU_PRIMAMMO || iSelectedNumber == MENU_SECAMMO || iSelectedNumber == MENU_INVALID) {
				if(getvar("allow_client_exec")) {
					execclient(User,"menuselect 10");
				}
			} else {
				g_UserMenuSelected[UserIndex] = iSelectedNumber;
			}
		}else if(g_UserMenuSelected[UserIndex] == MENU_RIFLES){
			get_userTeam(User,iTeam);
			if(iSelectedNumber==AWP_T || iSelectedNumber==AWP_CT){
				if(g_AwpTeamCount[iTeam]>=g_sb_awplimit){
					display_awp(User,iTeam);
					return PLUGIN_HANDLED;
				}else{
					g_AwpTeamCount[iTeam]+=1;
					g_AwpCount[UserIndex]=1;
					display_awp(User,iTeam);
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public awp(HLCommand,HLData,HLUserName,UserIndex){
	if(g_sb_awplimit !=0){
		new User[MAX_NAME_LENGTH];
		new iTeam;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		get_userTeam(User,iTeam);
		if(g_AwpTeamCount[iTeam]<=g_sb_awplimit){
			g_AwpTeamCount[iTeam]+=1;
			g_AwpCount[UserIndex]=1;
			display_awp(User,iTeam);
		}else{
			display_awp(User,iTeam);
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

public weapon_awp(HLCommand,HLData,HLUserName,UserIndex){
	if(g_sb_awplimit !=0 && g_commencing==0){
		new User[MAX_NAME_LENGTH];
		new iTeam;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		get_userTeam(User,iTeam);
		if(g_AwpCount[UserIndex]==0){
			g_AwpCount[UserIndex]=1;
			g_AwpTeamCount[iTeam]+=1;
		}
	}
	return PLUGIN_CONTINUE;
}

public awp_kill(HLCommand,HLData,HLUserName,UserIndex){
	if(g_sb_awplimit !=0){
		new Data[MAX_DATA_LENGTH];
		new Weapon[MAX_NAME_LENGTH];
		new Attacker[MAX_NAME_LENGTH];
		new Victim[MAX_NAME_LENGTH];
		new sAtt[3];
		new sVict[3];
		new iAtt;
		new iVict;
		new iATeam;
		new iVTeam;

		convert_string(HLData,Data,MAX_DATA_LENGTH);

		strsep(Data," ",sAtt,3,sVict,3,Weapon,MAX_NAME_LENGTH);
		
		iAtt=strtonum(sAtt);
		iVict=strtonum(sVict);
		
		if(playerinfo(iAtt,Attacker,MAX_NAME_LENGTH,_,_,iATeam)){
			if(playerinfo(iVict,Victim,MAX_NAME_LENGTH,_,_,iVTeam)){
				if(strncmp(Weapon,"awp",3)==0){
					if(g_AwpCount[iAtt]==0){
						g_AwpCount[iAtt] = 1;
						if(iATeam==1){
							g_AwpTeamCount[1]+=1;
						}else{
							g_AwpTeamCount[2]+=1;
						}
					}
				}

				if(g_AwpCount[iVict]==1){
					g_AwpCount[iVict] = MENU_NONE;
					g_AwpTeamCount[iVTeam]-=1;
				}
			}
		}
		
		
	}
	return PLUGIN_CONTINUE;
}

public awp_injure(HLCommand,HLData,HLUserName,UserIndex){
	if(g_sb_awplimit !=0){
		new Data[MAX_DATA_LENGTH];
		new Weapon[MAX_NAME_LENGTH];
		new Attacker[MAX_NAME_LENGTH];
		new sAtt[3];
		new sVict[3];
		new iAtt;
		new iATeam;

		convert_string(HLData,Data,MAX_DATA_LENGTH);

		strsep(Data," ",sAtt,3,sVict,3,Weapon,MAX_NAME_LENGTH);
		
		iAtt=strtonum(sAtt);
		
		if(playerinfo(iAtt,Attacker,MAX_NAME_LENGTH,_,_,iATeam)){
			if(g_AwpCount[iAtt]==0 && strncmp(Weapon,"awp",3)==0){
				g_AwpCount[iAtt] = 1;
				if(iATeam==1){
					g_AwpTeamCount[1]+=1;
				}else{
					g_AwpTeamCount[2]+=1;
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public awp_world(HLCommand,HLData,HLUserName,UserIndex){
	if(g_sb_awplimit !=0){
		new Data[MAX_DATA_LENGTH];
		new Player[MAX_NAME_LENGTH];
		new i;
		new maxplayers=maxplayercount();
		new iDead;
		
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		
		if(Data[0]=='G' || Data[8]=='R'){
			g_commencing=1;
			for(i=1;i<=maxplayers;i++){
				g_AwpCount[i] = MENU_NONE;
			}
			g_AwpTeamCount[1]=0;
			g_AwpTeamCount[2]=0;
		}else if(Data[6]=='S'){
			g_commencing=0;
		}else if(Data[6]=='E' && g_commencing==0){
			for(i=1;i<=maxplayers;i++){
				if(playerinfo(i,Player,MAX_NAME_LENGTH,_,_,_,iDead)){
					if(!iDead){
						execclient(Player,"hud_fastswitch 1");
						execclient(Player,"slot1");
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

display_awp(User[],iTeam){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	new Player[MAX_NAME_LENGTH];
	new intTeam;
	if(g_AwpTeamCount[iTeam]>g_sb_awplimit){
		snprintf(Text,MAX_TEXT_LENGTH,"You are not allowed to buy AWP. Your team uses %i of max. %i allowed AWPs",g_AwpTeamCount[iTeam],g_sb_awplimit);
		messageex(User,Text,print_chat);
	}else{
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Player,MAX_NAME_LENGTH,_,_,intTeam)){
				if(iTeam==intTeam){
					snprintf(Text,MAX_TEXT_LENGTH,"Your team has purchased %i of max. %i allowed AWPs.",g_AwpTeamCount[iTeam],g_sb_awplimit);
					messageex(Player,Text,print_chat);
				}
			}
		}
	}		
}

public plugin_connect(HLUserName,HLIP,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName,UserIndex) {
    if (0 < UserIndex < MAX_PLAYERS) {
        g_UserMenuSelected[UserIndex] = MENU_NONE;
        g_AwpCount[UserIndex] = MENU_NONE;
    }
    return PLUGIN_CONTINUE;
}
